namespace NXyn.Aux
    open System
    open System.Collections.Generic

    module DictMisc = 
        let TryGet (dict:Dictionary<'K,'V>) (key:'K) =
                   match dict.TryGetValue(key)
                    with | (true,value) -> Some(value)
                         | (false,_)    -> None
