namespace NXyn.Aux
    open System

    
    module Global =

        let AppName     = ref (Environment.GetCommandLineArgs()).[0]

        let InFileName  = ref ""
        let OutFileName = ref ""
        let LogFileName = ref ""

        let LogError(s:String) = if !LogFileName <> "" then let s = sprintf "[NXyn error] module=%s, inFile='%s', outfile='%s', error=%s" !AppName !InFileName !OutFileName s
                                                            ProcessMisc.append_line_to_file s !LogFileName |> ignore
                                 exit(2)

        let LogInfo(s:String) = if !LogFileName <> "" then let s = sprintf "[NXyn info] module=%s, inFile='%s', outfile='%s', info=%s" !AppName !InFileName !OutFileName s
                                                           ProcessMisc.append_line_to_file s !LogFileName |> ignore

