
module ListScheduling_Intel_Core2_Conroe

open System

open X64instr

open ListScheduling


//type XUnit = P0 | P1 | P2 | P3 | P4 | P5 (* ports 0/1/2/3/4/5 *)

//open 



//let (@) ncycles resource = TAKE_FOR(resource,ncycles)



let xuse_of_Instr (n:Int32) = 

(*
    let p0     = 1@P0
    let p1     = 1@P1
    let p2     = 1@P2
    let p34    = ALL [1@P3; 1@P4]
    let p5     = 1@P5
    let p0_1_5 = FIRST [p0;p1;p5] 
*)
(*
    let p0     = FIRST [2@P0a; ALL[2@P0b;PLUS(1)]]
    let p1     = FIRST [2@P1a; ALL[2@P1b;PLUS(1)]]
    let p2     = FIRST [2@P2a; ALL[2@P2b;PLUS(1)]]
    let p3     = FIRST [2@P3a; ALL[2@P3b;PLUS(1)]]
    let p4     = FIRST [2@P4a; ALL[2@P4b;PLUS(1)]]
    let p5     = FIRST [2@P5a; ALL[2@P5b;PLUS(1)]]
    let p34    = FIRST [ALL [2@P3a;2@P4a]; ALL[2@P3b;2@P4b;PLUS(1)]]
    let p0_1_5 = FIRST [2@P0a; 2@P1a; 2@P5a; ALL[FIRST[2@P0b;2@P1b;2@P5b]; PLUS(1)]]
*)


    let take1 (howlong:Int32) (f1)    = [0..n-1] |> List.map (fun(i) -> (i,if i = 0 then     TAKE(f1(i),n+howlong-1)                           else ALL[TAKE(f1(i),n+howlong-1);                          PLUS(i)]))
    let take2 (howlong:Int32) (f1,f2) = [0..n-1] |> List.map (fun(i) -> (i,if i = 0 then ALL[TAKE(f1(i),n+howlong-1); TAKE(f2(i),n+howlong-1)] else ALL[TAKE(f1(i),n+howlong-1); TAKE(f2(i),n+howlong-1); PLUS(i)]))

    let unsorted_to_XUnits(xs) = xs |> List.sortBy fst |> List.map snd

    let first1 (howlong:Int32) r1     =  r1      |> take1 howlong |> unsorted_to_XUnits |> FIRST
    let first2 (howlong:Int32) (r1,r2) = (r1,r2) |> take2 howlong |> unsorted_to_XUnits |> FIRST

    let p0(howlong:Int32)        = P0 |> first1 howlong
    let p1(howlong:Int32)        = P1 |> first1 howlong
    let p2(howlong:Int32)        = P2 |> first1 howlong
    let p5(howlong:Int32)        = P5 |> first1 howlong
    let p02(howlong:Int32)       = (P0,P2) |> first2 howlong
    let p12(howlong:Int32)       = (P1,P2) |> first2 howlong
    let p34(howlong:Int32)       = (P3,P4) |> first2 howlong
    let p25(howlong:Int32)       = (P2,P5) |> first2 howlong
    let p0_5(howlong:Int32)      = [P0;P5]                     |> List.map (take1 howlong) |> List.concat |> unsorted_to_XUnits |> FIRST
    let p0_1_5(howlong:Int32)    = [P0;P1;P5]                  |> List.map (take1 howlong) |> List.concat |> unsorted_to_XUnits |> FIRST
    let p02_12_25(howlong:Int32) = [(P0,P2); (P1,P2); (P2,P5)] |> List.map (take2 howlong) |> List.concat |> unsorted_to_XUnits |> FIRST

//    let p0  = FIRST (P0 |> take1 |> unsorted_to_XUnits)
//    let p1  = FIRST (P1 |> take1 |> unsorted_to_XUnits)
//    let p2  = FIRST (P2 |> take1 |> unsorted_to_XUnits)
//    let p5  = FIRST (P5 |> take1 |> unsorted_to_XUnits)

//    let p02 = FIRST ((P0,P2) |> take2 |> unsorted_to_XUnits)
//    let p12 = FIRST ((P1,P2) |> take2 |> unsorted_to_XUnits)
//    let p34 = FIRST ((P3,P4) |> take2 |> unsorted_to_XUnits)
//    let p25 = FIRST ((P2,P5) |> take2 |> unsorted_to_XUnits)



(*
    let p0     = FIRST ([0..n-1] |> List.map (fun(i) -> ALL[n@P0(i); PLUS(i)]))

    let p34    = FIRST
    
    3@P0a;                ALL[3@P0b;PLUS(1)];                      ALL[3@P0c;PLUS(2)]]
    let p1     = FIRST [3@P1a;                ALL[3@P1b;PLUS(1)];                      ALL[3@P0c;PLUS(2)]]
    let p2     = FIRST [3@P2a;                ALL[3@P2b;PLUS(1)];                      ALL[3@P0c;PLUS(2)]]
    let p3     = FIRST [3@P3a;                ALL[3@P3b;PLUS(1)];                      ALL[3@P0c;PLUS(2)]]
    let p4     = FIRST [3@P4a;                ALL[3@P4b;PLUS(1)];                      ALL[3@P0c;PLUS(2)]]
    let p5     = FIRST [3@P5a;                ALL[3@P5b;PLUS(1)];                      ALL[3@P0c;PLUS(2)]]
    let p34    = FIRST [ALL [3@P3a;3@P4a];    ALL[3@P3b;3@P4b;PLUS(1)];                ALL[3@P3c;3@P4c;PLUS(2)]]
    let p0_1_5 = FIRST [3@P0a; 3@P1a; 3@P5a;  ALL[FIRST[3@P0b;3@P1b;3@P5b]; PLUS(1)];  ALL[FIRST[3@P0c;3@P1c;3@P5c]; PLUS(2)]]
*)


    function
(*        (x:Instr) =
    match x with *)

        | R64sR64d(I_R64sR64d.Movq, _) -> p0_1_5(1)
        | R64sM64d(I_R64sM64d.Movq, _) -> p34(1)

        | M128sXd((I_M128sXd.Movaps | I_M128sXd.Movapd), _) -> p2(1)

        | M64sXd((I_M64sXd.Movq | I_M64sXd.Movsd), _) -> p2(1)
        | M64sXd(I_M64sXd.Movddup, _) -> p02(1)

        | M64sR64d(I_M64sR64d.Movq, _) -> p2(1)

        | R64d(I_R64d.Leaq(_), _) -> p0(1)



        | XsXd((I_XsXd.Movaps | I_XsXd.Movapd), _) -> p0_1_5(1)
        
        | XsXds((I_XsXds.Subpd | I_XsXds.Subps | I_XsXds.Addps | I_XsXds.Addpd), _) -> p1(1)
        | XsXds((I_XsXds.Mulps | I_XsXds.Mulpd), _) -> p0(1)


        | XsXds((I_XsXds.Xorps | I_XsXds.Xorpd), _) -> p0_1_5(1)
        | XsXds((I_XsXds.Unpcklpd | I_XsXds.Unpckhpd | I_XsXds.Shufpd _), _) -> p0(1)
        | XsXds((I_XsXds.Unpcklps | I_XsXds.Unpckhps | I_XsXds.Shufps _), _) -> p1(3)

        | M128sXds((I_M128sXds.Subpd | I_M128sXds.Subps | I_M128sXds.Addps | I_M128sXds.Addpd), _) -> p12(1)
        | M128sXds((I_M128sXds.Mulps | I_M128sXds.Mulpd), _) -> p02(1)

        | M128sXds((I_M128sXds.Xorps | I_M128sXds.Xorpd), _) -> p02_12_25(1)
        | M128sXds((I_M128sXds.Unpcklpd | I_M128sXds.Unpckhpd | I_M128sXds.Shufpd _), _) -> p02(1)
        | M128sXds((I_M128sXds.Unpcklps | I_M128sXds.Unpckhps | I_M128sXds.Shufps _), _) -> p12(3)

        | M64sR64ds((I_M64sR64ds.Addq | I_M64sR64ds.Subq), _) -> p02_12_25(1)

        | R64ds((I_R64ds.Decq | I_R64ds.Incq | I_R64ds.Subq _ | I_R64ds.Addq _), _) -> p0_1_5(1)
        | R64sR64s(I_R64sR64s.Testq, _) -> p0_1_5(1)
        | C(_) -> p5(1)
        
        | XsM128d((I_XsM128d.Movapd | I_XsM128d.Movaps), _) -> p34(1)

        | R64sR64d(I_R64sR64d.Imulq(_),_) -> p0(2)
        | R32sR32d(I_R32sR32d.Imull(_),_) -> p0(1)

        | M64sR64d(I_M64sR64d.Imulq(_),_) -> p02(2)
        | M32sR32d(I_M32sR32d.Imull(_),_) -> p02(1)


        | I0(I_I0.Retq)  -> p25(1)
        | I0(I_I0.Ret _) -> p25(1)


        | M64ds(I_M64ds.Shlq(_), _) -> ALL [p0(1);p5(1);p2(1);p34(1)]

        | x -> 
//            eprintfn "Intel_COre2: unknown xuse: %A" x
            TRUE
//            1@Dcod


(***)


(* all int register only instructions have latency 1 *)
let latency_of_Instr(x:Instr) =
    match x with
//        | R64sVd(I_R64sVd.Movq, _) -> 2
//        | VsR64d(I_VsR64d.Movq, _) -> 2

        | M64sR64d(I_M64sR64d.Movq, _) -> 3
        | R64sM64d(I_R64sM64d.Movq, _) -> 3

        | R32d(I_R32d.Leal(_), _) -> 1
        | R64d(I_R64d.Leaq(_), _) -> 1
                
        | R32sR32d(I_R32sR32d.Imull(_),_) -> 3
        | R64sR64d(I_R64sR64d.Imulq(_),_) -> 4
                

        (* all other integer register-to-register instructions have latency 1 *)

                                 
        | R8d _ | R16d _ | R32d _ | R64d _ -> 1

       
        | R8ds _ | R16ds _ | R32ds _ | R64ds _ -> 1
        | R8s _ | R16s _ | R32s _ | R64s _ -> 1
        | R8sR8s _ | R16sR16s _ | R32sR32s _ | R64sR64s _ -> 1
        
        | R8sR8d _ | R8sR16d _ | R8sR32d _ | R8sR64d _ | R16sR16d _ | R16sR32d _ | R16sR64d _ | R32sR32d _ | R32sR64d _ | R64sR64d _ -> 1
        | R8dsR8ds _ | R16dsR16ds _ | R32dsR32ds _ | R64dsR64ds _ -> 1
        | R8sR16sR16ds _ | R8sR32sR32ds _ | R8sR64sR64ds _ -> 1
        | R8sR8ds _ | R8sR16ds _ | R8sR32ds _ | R8sR64ds _ | R16sR16ds _ | R32sR32ds _ | R64sR64ds _ -> 1

                                  (* wrong numbers for shldw/... *)


        (* all other memory-to-register/register-to-memory instructions have latency 4 *)

        | M8d _ | M16d _ | M32d _ | M64d _ -> 4
        | M8ds _ | M16ds _ | M32ds _ | M64ds _ | M128ds _ -> 4
        | M8s _ | M16s _ | M32s _ | M64s _ -> 4

        | M8sR8d _ | M8sR16d _ | M8sR32d _ | M8sR64d _ | M16sR16d _ | M16sR32d _ | M16sR64d _ | M32sR32d _ | M32sR64d _ | M64sR64d _ -> 4
        
        | R8sM8d _ | R16sM16d _ | R32sM32d _ | R64sM64d _ -> 4

        | M8sR8ds _ | M16sR16ds _ | M32sR32ds _ | M64sR64ds _ -> 4
        | R8sM8ds _ | R16sM16ds _ | R32sM32ds _ | R64sM64ds _ -> 4
        | R8sR16sM16ds _ | R8sR32sM32ds _ | R8sR64sM64ds _ -> 4
        
        
        | M8dsR8ds _ | M16dsR16ds _ | M32dsR32ds _ | M64dsR64ds _ -> 4
        | R8dsM8ds _ | R16dsM16ds _ | R32dsM32ds _ | R64dsM64ds _ -> 4
        | R8sM8s _ | R16sM16s _ | R32sM32s _ | R64sM64s _ -> 4
        | M8sR8s _ | M16sR16s _ | M32sR32s _ | M64sR64s _ -> 4

(* exception:
imul
*)

(*
        | R64ds(I_R64ds.Decq,_) -> 1
        | R64sR64s(I_R64sR64s.Testq,_) -> 1
*)

        | M128sXd((I_M128sXd.Movaps | I_M128sXd.Movapd),_) -> 2

        | XsXd((I_XsXd.Movapd | I_XsXd.Movaps), _) -> 1

        | XsXds((I_XsXds.Xorpd | I_XsXds.Xorps), _) -> 1
        | XsXds((I_XsXds.Subpd | I_XsXds.Subps | I_XsXds.Addps | I_XsXds.Addpd), _) -> 3
        | XsXds(I_XsXds.Mulps, _) -> 4
        | XsXds(I_XsXds.Mulpd, _) -> 5

        | XsXds((I_XsXds.Shufpd _ | I_XsXds.Shufps _), _) -> 1
        
        | M128sXds((I_M128sXds.Xorpd | I_M128sXds.Xorps), _) -> 3
        | M128sXds((I_M128sXds.Subpd | I_M128sXds.Subps | I_M128sXds.Addps | I_M128sXds.Addpd), _) -> 5
        | M128sXds(I_M128sXds.Mulps, _) -> 6
        | M128sXds(I_M128sXds.Mulpd, _) -> 7
        | M128sXds((I_M128sXds.Shufpd _ | I_M128sXds.Shufps _), _) -> 4

        | XsM128d((I_XsM128d.Movapd | I_XsM128d.Movaps), _) -> 3

        | I0(I_I0.Retq) | I0(I_I0.Ret _) -> 4

        | C(_) -> 4
        | I0 _ -> 4
        | V0 _ -> 4

        (* indirect jumps/subroutine calls *)
        | NR64s _ | NM64s _ -> 4

        | _ -> //eprintfn "Intel Core2: unknown latency %A" x
               4

(***)

let cycle1 (n:Int32) (i:Int32) = if i < 0 then failwith "ListScheduling_Intel_Core2_Conroe.cycle1"
                                 let i = i-1
                                 if i < 0 then n-1 else i
                                 
let cycle_xunit (n:Int32) = function P0(i) -> P0(cycle1 n i)
                                   | P1(i) -> P1(cycle1 n i)
                                   | P2(i) -> P2(cycle1 n i)
                                   | P3(i) -> P3(cycle1 n i)
                                   | P4(i) -> P4(cycle1 n i)
                                   | P5(i) -> P5(cycle1 n i)
                                   | x -> x
  

let schedParams_ (n:Int32) =
                  { XResources           = [0..n-1] |> List.map (fun(i) -> [P0(i); P1(i); P2(i); P3(i); P4(i); P5(i)]) |> List.concat
                    MaxInstrsPerCycle    = 4
                    MaxIbytesPerCycle    = 16
                    MaxReadPorts         = 2
                    MaxOoOcycles         = 8
                    ReadPortNotNeededFor = 4
                    Mode                 = Thruput
                    GetXUse              = xuse_of_Instr n
                    GetLatency           = latency_of_Instr;
                    NextXRes             = cycle_xunit n }



let schedParams = schedParams_(5)
